package accrue.analysis.ext;

import accrue.analysis.pointer.AllocSiteNode;
import accrue.analysis.pointer.ConstructorContext;

public interface ExtAlloc extends AccrueExt {
    /**
     * Set the AllocSiteNode representing the allocation of a new object
     * (within the specific constructor context).
     */
    void setAllocNode(AllocSiteNode allocNode,
            ConstructorContext constructorContext);

    /**
     * Get the AllocSiteNode representing the allocation of a new object
     * (within the specific constructor context).
     */
    AllocSiteNode getAllocNode(ConstructorContext constructorContext);

}
