package accrue.analysis.ext;

import java.util.Map;

import polyglot.ast.Do;
import polyglot.util.SerialVersionUID;
import polyglot.visit.DataFlow;
import polyglot.visit.FlowGraph;
import polyglot.visit.FlowGraph.EdgeKey;
import polyglot.visit.FlowGraph.Peer;
import accrue.analysis.interprocanalysis.DataFlowDispatch;

public class ExtDo extends ExtLoop {
    private static final long serialVersionUID = SerialVersionUID.generate();

    @Override
    public <DFItem extends DataFlow.Item> Map<EdgeKey, DFItem> flowDispatch(
            DataFlowDispatch<DFItem> d, DFItem dfIn, DFItem trueItem,
            DFItem falseItem, FlowGraph<DFItem> graph, Peer<DFItem> peer) {
        Do n = (Do) this.node();
        return d.flowDo(n, dfIn, graph, peer);
    }
}
