package accrue.analysis.pointer;

import polyglot.types.Type;

/**
 * A PointsToGraphNode represents something that can point to an object. 
 * It includes ReferenceVariableReplica (i.e., a ReferenceVariable and a CContext)
 * and PointsToGraphNodeOF, i.e., a field of an abstract object. A PointsToGraph
 * is a data structure that describes the set of abstract objects that 
 * PointsToGraphNodes point to.
 * 
 */
public abstract class PointsToGraphNode {
    public abstract Type expectedType();
}
